ifMove					= {}
ifHide					= {}
local MoveAction	= {}


-----------------------


--[[ Public ]]    --WɈړ
function ifMove.To(posX, posY)
	MoveAction.MoveTo(posX, posY)
end

--[[ Public ]]    --Ɉړ
function ifMove.Left(cell)
	MoveAction.Left(cell)
end

--[[ Public ]]    --EɈړ
function ifMove.Right(cell)
	MoveAction.Right(cell)
end

--[[ Public ]]    --Ɉړ
function ifMove.Up(cell)
	MoveAction.Up(cell)
end

--[[ Public ]]    --Ɉړ
function ifMove.Down(cell)
	MoveAction.Down(cell)
end

--[[ Public ]]    --ActorɈړ
function ifMove.ToActor( ActorID )
	MoveAction.MoveToActor(ActorID)
end

--[[ Public ]]    --OwnerɈړ
function ifMove.ToOwner()
	MoveAction.MoveToOwner()
end

--[[ Public ]]    --ԋ߂thɈړ
function ifMove.NearFriend()
	MoveAction.MoveNearFriend()
end

--[[ Public ]]    --ԋ߂GɈړ
function ifMove.NearEnemy()
	MoveAction.MoveNearEnemy()
end

--[[ Public ]]    --ԊȂthɈړ@(UWĂȂ)
function ifMove.DangerFriend()
	MoveAction.MoveDangerFriend()
end

--[[ Public ]]    --ԊȂGɈړ@({XƂ)
function ifMove.DangerEnemy()
	MoveAction.MoveDangerEnemy()
end

--[[ Public ]]    --ΏۂƂ̒ w苗ꂽꏊɈړ
function ifMove.HoldRange(TargetID, Distance)
	MoveAction.MoveHoldRange(TargetID, Distance)
end


----------------------


--[[ Public ]]    --OwnerɂĉB
function ifHide.Owner(TargetID)
	MoveAction.MoveHideOwner(TargetID)
end

--[[ Public ]]    --thɂĉB
function ifHide.NearFriend(TargetID)
	MoveAction.MoveHideNearFriend(TargetID)
end

--[[ Public ]]    --ǂɉB
function ifHide.Wall()
	MoveAction.MoveHideWall()
end


-----------------------


--[[ Private ]]    --WɈړ
function MoveAction.MoveTo(pos1, pos2)
	if not My.IsDelay then
		if IsTable(pos1) then	--pos1.X pos1.ŶƂ
			Trace(" Move : " .. pos1.X .. " " .. pos1.Y)
			Move(My.ID, pos1.X, pos1.Y)
		else							--pos1  pos2 ̂Ƃ
			Trace(" Move : " .. pos2 .. " " .. pos2)
			Move(My.ID, pos1, pos2)
		end
		
		My.SetDelay( DELAY_MOVE )	--ړfBCݒ
		ifChangeState(ST_MOVE)		--ԂύX
	end
end


--[[ Public ]]    --Ɉړ
function MoveAction.Left(cell)
	local pos = Position.GetMyPosition()
	MoveAction.MoveTo(pos.X - cell, pos.Y)
end 

--[[ Public ]]    --EɈړ
function MoveAction.Right(cell)
	local pos = Position.GetMyPosition()
	MoveAction.MoveTo(pos.X + cell, pos.Y)
end

--[[ Public ]]    --Ɉړ
function MoveAction.Up(cell)
	local pos = Position.GetMyPosition()
	MoveAction.MoveTo(pos.X, pos.Y + cell)
end

--[[ Public ]]    --Ɉړ
function MoveAction.Down(cell)
	local pos = Position.GetMyPosition()
	MoveAction.MoveTo(pos.X, pos.Y - cell)
end

--[[ Private ]]    --ActorɈړ
function MoveAction.MoveToActor(ActorID)
	Trace("Move : Actor")
	MoveAction.MoveTo( GetV(V_POSITION, ActorID) )  --ʒu擾Ĉړ
end

--[[ Private ]]    --OwnerɈړ
function MoveAction.MoveToOwner()
	Trace("Move : Owner")
	MoveAction.MoveToActor( My.Owner.ID )	--OwnerActorɈړ
end

--[[ Private ]]    --ԋ߂ActorɈړ
function MoveAction.MoveNearActor( ActorIDList )
	local NearActor = Position.GetNearActor(ActorIDList, My.ID)	--ԋ߂th擾
	
	if IsTrue(NearActor) then						--߂Actor
		Trace("Move : NearActor")
		MoveAction.MoveToActor(NearActor)	--Actor̈ʒuɈړ
	else
		Trace("Move : NearActor  NotFound")
	end
end

--[[ Private ]]    --ԋ߂thɈړ@iƂj
function MoveAction.MoveNearFriend()
	local ActorIDList = ifFinding.GetActorIDList(ACT_FRIEND)	--thXg擾
	MoveAction.MoveNearActor(ActorIDList)
end

--[[ Private ]]    --ԋ߂GɈړ@i^QƂj
function MoveAction.MoveNearEnemy()
	local ActorIDList = ifFinding.GetActorIDList(ACT_ENEMY)
	MoveAction.MoveNearActor(ActorIDList)
end

--[[ Private ]]    --ԊȂthɈړ
function MoveAction.MoveDangerFriend()
	Trace("Move : DangerFriend")
end

--[[ Private ]]    --ԊȂGɈړ
function MoveAction.MoveDangerEnemy()
	Trace("Move : DangerEnemy")
end

--[[ Private ]]    --ΏۂƂ̒ w苗ꂽʒuɈړ
function MoveAction.MoveHoldRange(TargetID, Distance)
	Trace("Move : HoldRange")
	
	local HoldPosition = Position.GetPosition(TargetID, Distance)
	MoveAction.MoveTo(HoldPosition)
end


--------------------


--[[ Private ]]    --OwnerɉB
function MoveAction.MoveHideOwner(TargetID)
	Trace("Hide : Owner")
	local HidePosition = Position.GetHidePosition(TargetID, 2, My.Owner.ID)
	MoveAction.MoveTo(HidePosition)
end

--[[ Private ]]    --thɉB
function MoveAction.MoveHideNearFriend(TargetID)
	Trace("Hide : NearFriend")
	local FriendIDList	= ifFinding.GetActorIDList(ACT_FRIEND)
	local FriendID			= Position.GetNearActor(FriendIDList, My.ID)
	local HidePosition	= Position.GetPosition(TargetID, 2, FriendID)
	MoveAction.MoveTo(HidePosition)
end

--[[ Private ]]    --ǂɉB
function MoveAction.MoveHideWall()
	Trace("Hide : Wall")
end

