Tracer = {}


--[[ Private Parameter ]]
local TraceIndent	= -1
local TableIndent	= 1
local IndentLevel	= 2
local TraceList		= {first=-1, last=0}


--[[ Public ]]    --g[X@Labelo͂@Flag͊JnƏI@Level̓g[X̐[xilXgjw
function Trace( Label, Flag, Level )
	if TRACE_ON then
		local LabelType = type(Label)
		local FlagType  = type(Flag)
		
		if Level == nil then 
			Level = TraceIndent+1
		else
			--Level = Level + TraceIndent
		end
		
		if LabelType=="string"then
			if Level <= DEBUG_LEVEL then
				List.PushRight(TraceList, Label)
			end
		end
		
		if Label==TraceList[TraceList.last] then
			if Flag=="End" or Flag=="" or Flag==nil then
				List.PopRight(TraceList)
			end
			
			if LabelType == "number" then
				Label = tostring(Label)
				LabelType="string"
			end
			if FlagType  == "number" then
				Flag=tostring(Flag)
				FlagType ="string"
			end
			
			if LabelType=="string" and FlagType=="nil" then
				Tracer.Str(Label)
				
			elseif LabelType=="string" and FlagType=="string" then
				Tracer.Str(Label, Flag)
				
			elseif LabelType=="string" and FlagType=="table" then
				Tracer.Str(Label)
				Tracer.Tbl(Flag)
				
			elseif LabelType=="table" and FlagType=="nil" then
				Tracer.Tbl(Label)
					
			elseif LabelType=="table"  and FlagType=="string" then
				Tracer.Tbl(Label)
				Tracer.Str(Flag)
				
			elseif LabelType=="table"  and FlagType=="table" then
				Tracer.Tbl(Label)
				Tracer.Tbl(Flag)
				
			else
				assert(Label)
			end
		end
		
		PrevLevel = Level
	end
end

--[[ Public ]]    --o
function Tracer.Str( ... )
	-- String|Table,   String|Table|"Start"|"End",   TraceLevel|nil
	
	local Flag		="      "
	local StartFlg	=(TraceIndent+1) ..	" "
	local EndFlg	=TraceIndent ..		" "
	
	if arg[2] == "Start" then
		TraceIndent = TraceIndent + 1 
		Flag = StartFlg
		
	elseif arg[2] == "End" then
		Flag = EndFlg
	end

	
	local IndentString = "  . "
	
	for i = 0 , TraceIndent * IndentLevel do
		IndentString = IndentString.."  "
	end
	
	TraceAI(TICK_TIME.." "..IndentString..Flag..arg[1])
	
	if arg[2] == "End" then
		TraceIndent = TraceIndent - 1
	end
end

--[[ Public ]]    --e[uó@o͂͂ł邪݂̂߂ɂob܂̂Ŋ댯
function Tracer.Tbl(Table)
	for i, val in pairs( Table ) do
		if not( type(val) == "function") then
		
			TableIndent = (TableIndent + 1 )
			
			if Ask.IsTable( val ) then
				Tracer.Tbl(val)
			else
				if (TableIndent==0) or (TraceIndent+TableIndent-1==0) then
					Tracer.Str(i.." : "..val)
				else
					IndentString = ""
					for i = 0 , TableIndent do
						IndentString = IndentString.."  "
					end
					Tracer.Str(IndentString.."t"..TableIndent.." "..i.." : "..val)
				end
			end
			
			TableIndent = (TableIndent - 1 )
			
			if TableIndent == 1 then
				Trace("")
			end
		end
	end
end

--[[ Public ]]    --List.luãCfbNXó@{X=0 , Y=0} Ȃ "X" "Y"o͂
function Tracer.Index(list)	
	if unpack(list)==nil then
		TraceAI("    list item is nil")
	else
		for i, val in list do
			TraceAI("   " .. i .. "  " .. val )
		end
	end
end
-----------------------
